import { Observable } from 'rxjs';
declare type WebSocketPayload = string | ArrayBuffer | Blob;
export interface Connection<T extends WebSocketPayload = WebSocketPayload> {
    connectionStatus: Observable<number>;
    messages: Observable<T>;
}
export interface IWebSocket {
    close(): any;
    send(data: WebSocketPayload): any;
    onopen: ((event: any) => any) | null;
    onclose: ((event: any) => any) | null;
    onmessage: ((event: any) => any) | null;
    onerror: ((event: any) => any) | null;
}
export declare type WebSocketFactory = (url: string, protocols?: string | string[]) => IWebSocket;
export default function connect<T extends WebSocketPayload = WebSocketPayload>(url: string, input: Observable<WebSocketPayload>, protocols?: string | string[], websocketFactory?: WebSocketFactory): Connection<T>;
export {};
